package	ck_control;

use strict;
use lib '/home/dimmo/main';
use	Socket;
use	jury_common;
use	util::logger;
use 	IO::Handle;
use	Exporter;
use	j_config;

my $LIFETIME	= 10800;
my $epsilon	= 1e-4;

my $log = new util::logger( "$LOGDIR/ck_control.log" ) or die "error: can't create logfile: $!\n";
$log->info("INIT");

our @ISA = qw(Exporter);
our @EXPORT = qw(newRound launch check store retrieve);

sub newRound
{
	my $tid=shift;
	return 1;
}

sub launch
{
	my $tid = shift;
	return 1;
}

sub moveToPos
{
	my ($stime,$ctime,$lat,$lon,$rad,$vel,$x,$y,$z)=@_;
	my @A;
	my @A1;
	my @B;
	my @B1;
	my @C;
	my $alpha;
	$A[0][0] = cos($lon);
	$A[0][1] = 0;
	$A[0][2] = sin($lon);
	$A[1][0] = 0;
	$A[1][1] = 1;
	$A[1][2] = 0;
	$A[2][0] = -sin($lon);
	$A[2][1] = 0;
	$A[2][2] = cos($lon);
	$A1[0][0] = cos($lon);
	$A1[0][1] = 0;
	$A1[0][2] = -sin($lon);
	$A1[1][0] = 0;
	$A1[1][1] = 1;
	$A1[1][2] = 0;
	$A1[2][0] = sin($lon);
	$A1[2][1] = 0;
	$A1[2][2] = cos($lon);
	$B[0][0] = 1;
	$B[0][1] = 0;
	$B[0][2] = 0;
	$B[1][0] = 0;
	$B[1][1] = cos($lat);
	$B[1][2] = -sin($lat);
	$B[2][0] = 0;
	$B[2][1] = sin($lat);
	$B[2][2] = cos($lat);
	$B1[0][0] = 1;
	$B1[0][1] = 0;
	$B1[0][2] = 0;
	$B1[1][0] = 0;
	$B1[1][1] = cos($lat);
	$B1[1][2] = sin($lat);
	$B1[2][0] = 0;
	$B1[2][1] = -sin($lat);
	$B1[2][2] = cos($lat);
	$alpha = ($ctime - $stime) * $vel;
	$C[0][0] = cos($alpha);
	$C[0][1] = 0;
	$C[0][2] = sin($alpha);
	$C[1][0] = 0;
	$C[1][1] = 1;
	$C[1][2] = 0;
	$C[2][0] = -sin($alpha);
	$C[2][1] = 0;
	$C[2][2] = cos($alpha);
	my @r0;
	$r0[0][0] = $x;
	$r0[0][1] = 0;
	$r0[0][2] = 0;
	$r0[1][0] = $y;
	$r0[1][1] = 0;
	$r0[1][2] = 0;
	$r0[2][0] = $z;
	$r0[2][1] = 0;
	$r0[2][2] = 0;
	MultMatrix(\@B, \@C);
	MultMatrix(\@C, \@B1);
	MultMatrix(\@A, \@B1);
	MultMatrix(\@B1, \@A1);
	MultMatrix(\@A1, \@r0);
	return ($r0[0][0],$r0[1][0],$r0[2][0]);
}

sub MultMatrix
{
	my ($m1,$m2)=@_;
	my @temp;
	#M1 * M2
	for my $i (0..2)
	{
		for my $k (0..2)
		{
			$temp[$i][$k]=0;
			for my $l (0..2)
			{
				$temp[$i][$k]+=$m1->[$i][$l]*$m2->[$l][$k];
			}
		}
	}
	#M2 = result
	for my $i (0..2)
	{
		for my $k (0..2)
		{
			$m2->[$i][$k]=$temp[$i][$k];
		}
	}
}

sub PareMatrix
{
	my $m=shift;
	$m->[0][2]*=(-1);
	$m->[2][0]*=(-1);
}

sub check
{
	my @r;

	$log->info("Check called");
	my $teamID=shift;
	my ($tip,$tipalien)=getTeamIPs($teamID);
	my ($time)=getGameTime();
	my $ctime=$time;
#	$time+=int(rand(3599))+1;
	my $PORT = '10666';
	socket(S,PF_INET,SOCK_STREAM,getprotobyname('tcp')) or do{
		$log->error("Could not create socket: $!");
		return ( 0, "socket: $!" );
	};
	my $address=sockaddr_in($PORT, inet_aton($tip));
	$log->debug("Connecting to Control at $tip...");
	connect( S,$address ) or do
	{
		my @r = ( 4, $! );
		$log->error("Could not connect to $tip");
		return @r;
	};
	$log->debug("Done");
	autoflush S;
	print S "Action=Status\r\n\r\n\r\n";
	my $a=<S>;
	$a=~s/[\r\n]//g;
	close(S);
	$log->debug("Got answer: $a");
	my @res;
	if($a =~ /^ON/)
	{
		my $ok=1;
		$log->debug("Connecting to Control at $tip...");
		socket(S,PF_INET,SOCK_STREAM,getprotobyname('tcp')) or do
		{
			@r = ( 0, $! );
			$log->error("Could not create socket: $!");
			return @r;
		};
		connect(S,$address) or do
		{
			@r = ( 4, $! );
			$log->error("Could not connect to $tip");
			return @r;
		};
		$log->debug("Done");
		autoflush S;
		print S "Action=EList&Time=$time\r\n\r\n\r\n";
		my %a;
		while(<S>)
		{
			s/[\r\n]//g;
			$log->debug("Received |$_|");
			last if($_ eq '');
			/([^\t]+)\t\(([^,]+),([^,]+),([^,]+),([^,]+),([^,]+),([^,]+),([^,]+),([^,]+)\)/;
			$a{$1}=[$2,$3,$4,$5,$6,$7,$8,$9];
		}
		close(S);
		$log->debug("Received ".scalar(keys %a));
		my @a=getSputniksEx($teamID,$time-$LIFETIME);
		$log->debug("In base ".scalar(@a));
		for(@a)
		{
			my $t=$a{$_->[0]};
			if($t && @$t)
			{
				my $o=1;
				my ($lat,$lon,$rad)=split(/ /,$_->[2]);
				my ($x,$y,$z,$v)=split(/ /,$_->[3]);
				$log->debug("Satellite ".$_->[0]."| Orbit $lat, $lon, $rad");
				my @pos;
#				if(-e "ck_formula")
#				{
#					my $s=`ck_formula $lat $lon $rad $x $y $z $v $_->[1] $time`;
#					chomp $s;
#					@pos=($lat,$lon,$rad,split(/\t/,$s),$v,$time);
#				}else{
					@pos=($lat,$lon,$rad,moveToPos($_->[1],$time,$lat,$lon,$rad,$v,$x,$y,$z),$v,$time);
#				}
				$log->debug("Move from $x,$y,$z to ".join(",",@pos[3..5])." with speed $v from time $_->[1] to time $time");
				for(0..2)
				{
					$o=0 if(abs($pos[$_] - ${$t}[$_]) > $epsilon);
				}
				$log->debug("Comparison gave $o");
				if($o)
				{
					delete $a{$_->[0]};

					$o=1;
					for(0..7)
					{
						$log->debug($pos[$_].' = '.${$t}[$_].' => '.abs($pos[$_] - ${$t}[$_]));
						$o=0 if(abs($pos[$_] - ${$t}[$_]) > $epsilon);
					}
					$log->debug("MovComparison gave $o");
					if(!$o)
					{
						$ok=0;
						$a="Wrong satellite position";
					}
				}
			}else{
				$ok=0;
				if($a =~ /^Missing satellite/)
				{
					$a.=", $_->[0]";
				}else{
					$a="Missing satellite, $_->[0]";
				}
			}
		}
		$log->debug("Extra satellites from Control: ".scalar(keys %a));
		for(keys %a)
		{
			my $k=$a{$_};
			my ($lat,$lon,$rad,$x,$y,$z,$v,$t)=@$k;
			if(isOrbitReserved("$lat $lon $rad"))
			{
				$log->debug("Satellite $_ registered");
				setSputnikPosOrbit($teamID,$_,"$lat $lon $rad","$x $y $z $v",int($ctime));
			}else{
				$log->debug("Satellite $_ wrong");
				$ok=-1 if($ok);
				if($a =~ /^Extra satellite found/)
				{
					$a.=", $_";
				}else{
					$a="Extra satellite found";
				}
			}
		}
		if($ok > 0)
		{
			unshift @res,1;
			$a="All fine";
		}else{
			unshift @res,2-$ok;
		}
	}else{
		unshift @res,3;
	}
	push @res,$a;
	$log->debug("Done");
	s/\r//g for(@res);
	return @res;
}

sub store
{
	my @r;

	$log->info("Store called");
	my $PORT='10666';
	my ($teamID,$flagID,$flag)=@_;
	my ($tip,$tipalien)=getTeamIPs($teamID);

	my $sauth=getSputnikAuth($flagID);
	return ( 0, "getSputnikAuth( $flagID ) failed" ) if !$sauth;

	socket(S,PF_INET,SOCK_STREAM,getprotobyname('tcp')) or do
	{
		@r = ( 0, $! );
		$log->error("Could not create socket: $!");
		return @r;
	};
	my $address=sockaddr_in($PORT,inet_aton($tip));
	$log->debug("Connecting to Control...");
	connect(S,$address) or do
	{
		@r = ( 4, $! );
		$log->error("Could not connect to $address");
		return @r;
	};
	$log->debug("Done");
	autoflush S;
	$log->debug("Action=ChangeModel\nID=$flagID\nUID=$sauth\nModel=$flag\\r\\n\\r\\n\\r\\n");
	print S "Action=ChangeModel\&ID=$flagID\&UID=$sauth\&Model=$flag\r\n\r\n\r\n";
	my $a=<S>;
	$a=~s/[\r\n]//g;
	close(S);
	$log->debug("Done");
	$log->debug("Compare |$a| with |$flag|");
	if($a eq $flag)
	{
		$log->debug("OK");
		return(1, $flag );
	}elsif($a =~ /^Invalid/){
		$log->error("Wrong flag");
		return (3,$a);
	}else{
		$log->error("Wrong flag");
		return (3,"Wrong Model returned");
	}
}

sub retrieve
{
	$log->info("Retrieve called");
	my $PORT='10666';
	my ($teamID,$flagID,$flag)=@_;
	my ($tip,$tipalien)=getTeamIPs($teamID);

	my $sauth=getSputnikAuth($flagID);
	return ( 0, "getSputnikAuth( $flagID ) failed" ) if !$sauth;

	socket(S,PF_INET,SOCK_STREAM,getprotobyname('tcp')) or do{$log->error("Could not create socket: $!");return 0;};
	my $address=sockaddr_in($PORT,inet_aton($tip));
	$log->debug("Connecting to Control...");
	connect(S,$address) or do{
		$log->error("Could not connect to $address");
		return (4,"connect: $!");
	};
	$log->debug("Done");
	autoflush S;
	$log->debug("Action=Model\nID=$flagID\nUID=$sauth\\r\\n\\r\\n\\r\\n");
	print S "Action=Model\&ID=$flagID\&UID=$sauth\r\n\r\n\r\n";
	my $a=<S>;
	$a=~s/[\r\n]//g;
	close(S);
	$log->debug("Done");
	$log->debug("Compare |$a| with |$flag|");
	if($a eq $flag)
	{
		$log->debug("  -> match!");
		return (1,$flag);
	}elsif($a =~ /^Invalid/){
		$log->error("  -> wrong flag");
		return ( 2, $a );
	}else{
		$log->error("  -> wrong flag");
		return ( 3, "Bad answer");
	}
}

1;
