#!/usr/bin/perl
package ck_gagarin;

use strict;
use Socket;
use lib '/home/dimmo/main';
use util::logger;
use j_config;
use jury_common;
use Exporter;

our @EXPORT = qw(check store retrieve);
our @ISA = qw(Exporter);

use constant {
	INT_ERR => 0,
	UP => 1,
	CORRUPT => 2,
	VCORRUPT => 3, 
	DOWN => 4
};

# 0 - internall error
# 1 - ok
# 2 - corrupt
# 3 - very corrupt
# 4 - down

my $rport = 8080;
my $log = new util::logger( "$LOGDIR/ck_gagarin.log" ) or die "can't create util::log\n";

END {
	$log -> info( "END: retval = $?; lasterror = $!");
}

my @r = split '', '1234567890qwertyuiopasdfghklzxcvbnmQWERTYUIOPASDFGHJKLZXCVBNM';

sub genstr {
	my $r = '';
	for (1..20) {
		$r .= $r[int rand @r];
	}
	$r;
}

sub check
{
	my ( $tid ) = @_;
	$log -> info( "check( @_ )" );

	my ( $ip ) = getTeamIPs( $tid )						or return( INT_ERR, "getTeamIPs( $tid ) failed" );
	$log -> info( "   found ip: $ip" );

	socket S, PF_INET, SOCK_STREAM, 0					or return ( INT_ERR, $! );
	connect S, sockaddr_in($rport, inet_aton $ip )				or return ( DOWN, $! );

	my $r = "GET / HTTP/1.0\r\n\r\n";
	send S, $r, 0;
	recv S, $_, 1000000, 0;
	shutdown S, 2;

	if ( /^HTTP\/1\.1 200 OK/ ) {
		$log -> info( "   200 OK - return 0" );
		return ( UP, "ok" );
	}
	else {
		$log -> info( "   bad answer:\n >> $_ <<\n" );
		return ( DOWN, "not 200 OK answer" );
	}
}

sub store
{               
	my ( $tid, $fid, $flag ) = @_;
	$log -> info( "store( @_ )" );

	my ( $ip ) = getTeamIPs( $tid )						or return( INT_ERR, "getTeamIPs( $tid ) failed" );
	$log -> info( "   found ip: $ip" );

	socket S, PF_INET, SOCK_STREAM, 0					or return ( INT_ERR, $! );
	connect S, sockaddr_in( $rport, inet_aton $ip )				or return ( DOWN, $! );

	send S, "ppp $fid$flag HTTP/1.0\r\n\r\n", 0;
	shutdown S, 2;

	return (UP, $flag);
}

sub retrieve
{
	my ( $tid, $fid, $flag ) = @_;
	$log -> info( "store( @_ )" );

	my ( $ip ) = getTeamIPs( $tid )						or return( INT_ERR, "getTeamIPs( $tid ) failed" );
	$log -> info( "   found ip: $ip" );

	socket S, PF_INET, SOCK_STREAM, 0					or return( INT_ERR, $! );
	connect S, sockaddr_in( $rport, inet_aton $ip )				or return( DOWN, $! );

	send S, "ggg $fid HTTP/1.0\r\n\r\n", 0;
	local $_ = '';
	my $buf;
	$_ .= $buf while defined recv( S, $buf, 100000, 0) && length $buf;
	shutdown S, 2;

	if (/\r\n\r\n(.*)/s) {
		if ($1 eq $flag) {
			return ( UP, 'flag found' );
		}
	}
	$log -> info( "  flag not found:\n >> $_ <<" );
	return ( CORRUPT, 'flag not found' );
}

1;

