#!/usr/bin/perl

#
#	Simple debugger for RuCTF checkers. v0.0.2
#
#	(c) Simonov Dmitry, 2008
#

use strict;
no strict 'refs';
++$|;

# ----------------------------------------------------------

my $timeout = 10;
my %codes = (
	0	=> 'internal checker error',
	1	=> 'operation completed successfully',
	2	=> 'remote malfunction',
	3	=> 'remote malfunction (serious)',
	4	=> 'remote service down',
);

# ----------------------------------------------------------

@ARGV < 3 and die
	"usage: dbg_checker.pl <serv_name> <sub_name> <arg1> [arg2] ...\n",
	"\t\tserv_name :  ( control | data | alien | start | web )\n",
	"\t\tsub_name  :  ( check | newRound | launch | store | retrieve )\n",
	"\t\targN      :  depends on serv_name and sub_name\n";

my ( $serv_name, $sub_name, @args ) = @ARGV;

$SIG{ALRM} = sub { die "TIMEOUT ($timeout sec)\n" };
alarm $timeout;

# ----------------------------------------------------------

local $" = "', '";

my @ret;
my $OLD_FH = select;			# Save old value

my $code=<<"EVAL";

	use lib '/home/dimmo/main';
	use jury_common;

	dbConnect( );

	print "   use ... ";
	use ck_$serv_name;
	print "OK\\n";

	print "invoke ... ";
	\@ret = $sub_name( '@args' );
	print "OK\\n";

EVAL

select $OLD_FH;

print '-'x60,$/;
print $code;
print '-'x60,$/;

eval $code;
if ( $@ ) {
	print "FAIL\n";
	print '-'x60,$/;
	print "$@\n";
}
print '-'x60,$/;

$_ =~ s/[\r\n]//g for @ret;

local $" = "', '";
print "\@ret = ( '@ret' )\n";

my ( $code ) = @ret;
printf "$code is '%s' $/$/", ( $codes{$code} || "UNKNOWN CODE!" );

