#include <iostream>
#include <math.h>

using namespace std;

void MultMatrix(double m1[3][3], double m2[3][3])
{
	double temp[3][3];
	//M1 * M2
	for(int i = 0; i < 3; i++)
	{
		for(int k = 0; k < 3; k++)
		{
			temp[i][k] = 0;
			for(int l = 0; l < 3; l++)
			{
				temp[i][k] += m1[i][l] * m2[l][k];
			}
		}
	}
	//M2 = result
	for(int i = 0; i < 3; i++)
	{
		for(int k = 0; k < 3; k++)
		{
			m2[i][k] = temp[i][k];
		}
	}
}

void PareMatrix(double m[3][3])
{
	m[0][2] *= -1;
	m[2][0] *= -1;
}

int main(int argc, char *argv[])
{
	if ( argc != 10 ) {
		printf( "give me 9 args not %d!\n", argc - 1 );
		return 1;
	}

	double lat,lon,rad;
	double x,y,z,v;
	double pt,ct;
	lat = atof(argv[1]);
	lon = atof(argv[2]);
	rad = atof(argv[3]);
	x = atof(argv[4]);
	y = atof(argv[5]);
	z = atof(argv[6]);
	v = atof(argv[7]);
	pt = atof(argv[8]);
	ct = atof(argv[9]);
	double A[3][3];
	double A1[3][3];
	double B[3][3];
	double B1[3][3];
	double C[3][3];
	double alpha;
	A[0][0] = cos(lon);
	A[0][1] = 0;
	A[0][2] = sin(lon);
	A[1][0] = 0;
	A[1][1] = 1;
	A[1][2] = 0;
	A[2][0] = -sin(lon);
	A[2][1] = 0;
	A[2][2] = cos(lon);
	A1[0][0] = cos(lon);
	A1[0][1] = 0;
	A1[0][2] = -sin(lon);
	A1[1][0] = 0;
	A1[1][1] = 1;
	A1[1][2] = 0;
	A1[2][0] = sin(lon);
	A1[2][1] = 0;
	A1[2][2] = cos(lon);
	B[0][0] = 1;
	B[0][1] = 0;
	B[0][2] = 0;
	B[1][0] = 0;
	B[1][1] = cos(lat);
	B[1][2] = -sin(lat);
	B[2][0] = 0;
	B[2][1] = sin(lat);
	B[2][2] = cos(lat);
	B1[0][0] = 1;
	B1[0][1] = 0;
	B1[0][2] = 0;
	B1[1][0] = 0;
	B1[1][1] = cos(lat);
	B1[1][2] = sin(lat);
	B1[2][0] = 0;
	B1[2][1] = -sin(lat);
	B1[2][2] = cos(lat);
	alpha = (ct - pt) * v;
	C[0][0] = cos(alpha);
	C[0][1] = 0;
	C[0][2] = sin(alpha);
	C[1][0] = 0;
	C[1][1] = 1;
	C[1][2] = 0;
	C[2][0] = -sin(alpha);
	C[2][1] = 0;
	C[2][2] = cos(alpha);
	double r0[3][3];
	r0[0][0] = x;
	r0[0][1] = 0;
	r0[0][2] = 0;
	r0[1][0] = y;
	r0[1][1] = 0;
	r0[1][2] = 0;
	r0[2][0] = z;
	r0[2][1] = 0;
	r0[2][2] = 0;
	MultMatrix(B, C);
	MultMatrix(C, B1);
	MultMatrix(A, B1);
	MultMatrix(B1, A1);
	MultMatrix(A1, r0);
	x = r0[0][0];
	y = r0[1][0];
	z = r0[2][0];
	printf( "%.14f\t%.14f\t%.14f\n", x, y, z );

	return 0;
}
