#!/usr/bin/perl

use strict;
use lib '..';
use util::logger;

# ----- configguration --------

my $logfile = 'example.log';

# -----------------------------

my $log;

$log = new util::logger( $logfile ) or die "error: can't create logfile: $!\n";
$log -> info( "   *** PROCESS STARTED\n" );

$SIG{__DIE__} = sub
{
	chomp( my $msg = shift );
	
	$log -> alert( "  *** Oops! PROCESS DIED. Reason: '$msg'\n" );
	for ( 0 .. 90 ) {
		my ( $pkg, $fname, $line, $sub ) = caller( $_ ) or last;
		$fname =~ s|^.*\\||;
		$fname =~ s|^.*/||;
		$log -> alert( sprintf "    (%2d)  pkg: %-10s  file: %-25s  sub: %s( )\n", $_, $pkg, "$fname:$line", $sub );
	}
	exit 1;
};

END {
	$log -> info( "   *** PROCESS FINISHED\n" );
}

## ------------- You can copy-paste from start of the file till this line ---------------------

$log -> debug( 'some debug messages ...' );
sub xx {
	die( "something bad happened!\n" );
}
sub yy {
	$log -> debug( "yy( @_ )" );
	xx();
}
sub zz {
	$log -> debug( "zz( @_ )" );
	yy( 666, @_ );
}
zz( 123, 'asd' );
