package j_config;

use strict;
use Exporter;

our @ISA = qw( Exporter );
our @EXPORT = qw(

	$LOG_MAIN
	$LOG_TEAMS_TEMPLATE
	$LOG_TEAMS_BANK
	$LOG_TEAMS_SQL
	$LOG_TEAMS_BRIEF
	$LOG_IP

	$LOGDIR

	$BANK_HOST
	$BANK_PORT

	$SAT_PER_ROUND
	$MIL_PER_ROUND

	@STATUS_COST

	$TIMEOUT_CHILD

	$TIMEOUT_NEW_ROUND
	$TIMEOUT_CHECK
	$TIMEOUT_STORE
	$TIMEOUT_RETR
	$TIMEOUT_LAUNCH
	
	$GAMETIME_ROUND

	$LIFE_RESERVED
	$LIFE_SPUTNIK
	$LIFE_FLAG

	$FLAG_ALF

	@SERV_ALL
	@SERV_NEWROUND
	@SERV_STORE_STD
	@SERV_RAND_RETR

	$NUM_RAND_FLAGS
);

# --------- Logs constants 

our $LOGDIR		= '/home/dimmo/main/logs';

our $LOG_MAIN		= "$LOGDIR/main.log";
our $LOG_TEAMS_TEMPLATE	= "$LOGDIR/team.%s";
our $LOG_TEAMS_BANK	= "$LOGDIR/bank.%s";
our $LOG_TEAMS_SQL	= "$LOGDIR/sql.%s";
our $LOG_TEAMS_BRIEF	= "$LOGDIR/team.brief.%s";
our $LOG_IP		= "$LOGDIR/ip.log";


# --------- Network constants

our $BANK_HOST		= 'jury.ructf';
our $BANK_PORT		= 2020;

# --------- Timeouts for checker's subs

our $TIMEOUT_CHILD	= 400;		# sec

our $TIMEOUT_NEW_ROUND	= 9;
our $TIMEOUT_CHECK	= 14;
our $TIMEOUT_STORE	= 14;
our $TIMEOUT_RETR	= 14;
our $TIMEOUT_LAUNCH	= 22;

# --------- Game time constants 

our $GAMETIME_ROUND	= 3600;			# seconds of gametime
our $LIFE_RESERVED	= 2*$GAMETIME_ROUND;	# seconts of gametime
our $LIFE_SPUTNIK	= 3*$GAMETIME_ROUND;	# seconds of gametime
our $LIFE_FLAG		= $LIFE_SPUTNIK;	# MUST be equal !

our $NUM_RAND_FLAGS	= 1;			# random flags to check per round

our $SAT_PER_ROUND	= 1;
our $MIL_PER_ROUND	= 1;

our @STATUS_COST	= ( 0, 8, 2, 1, 0 );

#
# --------- Other constants

our $FLAG_ALF		= '_abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-/';	# w/o + and \ 

# --------- Services list constants

our @SERV_ALL		= qw( start control data alien web spy gagarin );		# list of all services
our @SERV_STORE_STD	= qw( web spy gagarin );				# store with rand $fid
our @SERV_NEWROUND	= qw( start data );
our @SERV_RAND_RETR	= qw( control data alien web spy gagarin );

1;

