#!/usr/bin/perl

use strict;
use lib '/home/dimmo/main/';
use jury_common;
use util::mailer;
use Socket;

++$|;

my $POINTS = 10;

dbConnect( );

my $tid = shift or die "give tid as arg\n";

my %payed;

open LOG, ">> log.payed" or die;

open F, "payed.$tid";
while ( <F> ) {
	chomp;
	$payed{ $_ } = 1;
}
close F;

my $mail = getTeamMail( $tid ) or die "error: getTeamMail\n";

for ( getPostedFlags( $tid ) )
{
	if ( ! $payed{ $_ } )
	{
		print " flag: $_ ... ";

		my $ck = getCheck( $POINTS )	or die "error: getCheck failed\n";

		my $c = sendTeamMail( $tid, "$POINTS points for posted flag", "your check: $ck" );
		$c and die "   ERROR: sendTeamMail: $c\n";
#		my $c = sendTeamMail( 'j', "COPY: $POINTS points for posted flag", "your check: $ck" );

		syswrite LOG, "team $tid is given $POINTS points for flag $_, check is $ck\n";

		$payed{ $_ } = 1;

		print "ok\n";
	}
}

close LOG;

open F, "> payed.$tid";
print F "$_\n" for keys %payed;
close F;


sub getCheck($)
{
        my $sum = pop;

        socket( S, PF_INET, SOCK_STREAM, 0 ) or die "$!\n";
        my $addr = inet_aton 'jury.ructf'      or die "$!\n";
        connect( S, sockaddr_in( 2020, $addr ) )  or do die "$!\n";

        my $req = "get_check $sum";
        send( S, $req."\r\n", 0 );

        recv( S, my $reply, 1024, 0 );
        $reply =~ s/[\r\n]+$//;

        close S;

        if ( $reply =~ /^\+(\+[A-Za-z0-9_\/\+\-]+)/ )
        {
                return $1;
        }
        else
        {
                return undef;
        }
}

