#!/usr/bin/perl

#
# sv_kost v0.0.1
#
# Copyright (c) Simonov Dmitry, 2008
#

use strict;
use Socket;
use lib '/home/dimmo/main';
use util::logger;
use jury_common;
use j_config;

++$|;

my $nl = "\r\n";

# ----------------------- config -------------------------

my $LOGFILE	= 'logs/sv_kost.log';
my $OUT_FILE	= 'kost.out.txt';
my $SLEEP	= 60;
my $UPLOAD_CMD	= "scp -i /home/dimmo/.ssh/dimmo1.hackerdom -P 62674 $OUT_FILE hackerdom.ru:/var/www/htdocs/www.ructf.org/";

# -------------------- end of config ---------------------

dbConnect( );

my $log = new util::logger( $LOGFILE ) or die "error: util::logger failed: $!\n";
print $log -> info( " -------------------------- START ------------------------------ " );

while ( 1 )
{
	my $g = getGameTime( );
	my @s = getSputniksEx( undef, getGameTime() - $LIFE_SPUTNIK );

	open F, "> $OUT_FILE" or die "error: open: $!\n";
	for ( @s ) {
		my ( $sid, $startTime, $sorbit, $startPos ) = @$_;
		syswrite F, "$sid $sorbit $startPos $startTime".$nl;
	}
	close F;

	print $log->info( sprintf "game time: %-9s, sputniks: %-5d\n", $g, 0+@s );

	system( $UPLOAD_CMD );
	if ( $@ ) {
		print $log->warning( "  upload: FAILED: $@" );
	}
	else {
		print $log->info( "  upload: OK" );
	}

	sleep $SLEEP;
}

