#
# tiny logger v0.0.2
#
# (c) 2008 Simonov Dmitry
#

package	util::logger;

use strict;
use Exporter;
use POSIX;

# ------------------ Config -----------------

my $fmt = '%Y/%m/%d  %H:%M:%S';
my $nl  = "\r\n";

# --------------- End of Config -------------

our @ISA = qw( Exporter	);

our @EXPORT = qw( new debug info warning error alert );

sub new($)
{
	my ( $class, $fname ) = @_;
	
	open my $F, ">> $fname" 	or return undef;

	my $this = {
		FNAME		=> $fname,
		F		=> $F,
	};
	return bless( $this, $class );
}

sub fname()
{
	my ( $this ) = @_;
	return $this->{FNAME};
}

sub write_log
{
	my ( $this, $level, $msg ) = @_;
	chomp $msg;
	
	my $s_time = strftime '%Y/%m/%d  %H:%M:%S', localtime();
	
	syswrite $this->{F}, sprintf( "%s  %7s  %9s  %s".$nl, $s_time, "{$$}", "[$level]", $msg );
	
	$msg.$nl;
}

sub debug {
	my ( $self, $msg, @par ) = @_;
	write_log( $self, 'DEBUG', sprintf( $msg, @par ) ); 
}

sub info {
	my ( $self, $msg, @par ) = @_;
	write_log( $self, 'INFO', sprintf( $msg, @par ) ); 
}

sub warning {
	my ( $self, $msg, @par ) = @_;
	write_log( $self, 'WARN', sprintf( $msg, @par ) ); 
}

sub error {
	my ( $self, $msg, @par ) = @_;
	write_log( $self, 'ERROR', sprintf( $msg, @par ) ); 
}

sub alert {
	my ( $self, $msg, @par ) = @_;
	write_log( $self, 'ALERT', sprintf( $msg, @par ) );
	syswrite STDERR, sprintf( $msg.$nl, @par );
}

1;

