
package util::mailer;

use strict;
use Exporter;
use lib '/home/dimmo/main/';
use jury_common;
use Socket;
use j_config;

our @ISA = qw( Exporter );
our @EXPORT = qw(
	sendTeamMail
);

# -------------- config ----------------

my $PORT     = 25;
my $FROM     = 'no_reply@jury.ructf';
my $LOGNAME  = "$LOGDIR/mailer.log";

# ---------- end of config -------------

my $log = new util::logger( $LOGNAME ) 		or die "error: can't create util::logger( $LOGNAME )\n";

# ------------------------------- S U B R O U T I N E S ---------------------------------

sub sendTeamMail($$$)
{
	my ( $tid, $subj, $msg ) = @_;
	my $to = getTeamMail( $tid )			or return "getTeamMail failed";

	$to =~ /\@(.*)/;

	socket( S, PF_INET, SOCK_STREAM, 0 )		or return "$!";
	my $adr = inet_aton $1				or return "$!";
	connect( S, sockaddr_in( $PORT, $adr ) )	or return "$!";

	my $data = join( "\r\n",
				"HELO pupsik",
				"MAIL FROM: $FROM",
				"RCPT TO: $to",
				"DATA",
				"From: $FROM",
				"To: $to",
				"Subject: $subj",
				"",
				$msg,
				".",
				"DATA",
				""
	);
	defined send( S, $data, 0 ) 			or return "$!";
	close( S );

	$log -> info( sprintf "%s %-23s %-30s %s", $tid, $to, $subj, $msg );

	0;		# ok
}

